/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery, DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQueryOutputReference, DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery, DashboardWidgetToplistDefinitionRequestRumQueryComputeQueryOutputReference, DashboardWidgetToplistDefinitionRequestApmQuery, DashboardWidgetToplistDefinitionRequestApmQueryOutputReference, DashboardWidgetToplistDefinitionRequestAuditQuery, DashboardWidgetToplistDefinitionRequestAuditQueryOutputReference, DashboardWidgetToplistDefinitionRequestConditionalFormats, DashboardWidgetToplistDefinitionRequestConditionalFormatsList, DashboardWidgetToplistDefinitionRequestFormula, DashboardWidgetToplistDefinitionRequestFormulaList, DashboardWidgetToplistDefinitionRequestLogQuery, DashboardWidgetToplistDefinitionRequestLogQueryOutputReference, DashboardWidgetToplistDefinitionRequestProcessQuery, DashboardWidgetToplistDefinitionRequestProcessQueryOutputReference, DashboardWidgetToplistDefinitionRequestQuery, DashboardWidgetToplistDefinitionRequestQueryList, DashboardWidgetToplistDefinitionCustomLink, DashboardWidgetToplistDefinitionCustomLinkList, DashboardWidgetSunburstDefinition, DashboardWidgetSunburstDefinitionOutputReference, DashboardWidgetTimeseriesDefinition, DashboardWidgetTimeseriesDefinitionOutputReference } from './structs6000';
import { DashboardWidgetAlertGraphDefinition, DashboardWidgetAlertGraphDefinitionOutputReference, DashboardWidgetAlertValueDefinition, DashboardWidgetAlertValueDefinitionOutputReference, DashboardWidgetChangeDefinition, DashboardWidgetChangeDefinitionOutputReference, DashboardWidgetCheckStatusDefinition, DashboardWidgetCheckStatusDefinitionOutputReference, DashboardWidgetDistributionDefinition, DashboardWidgetDistributionDefinitionOutputReference, DashboardWidgetEventStreamDefinition, DashboardWidgetEventStreamDefinitionOutputReference, DashboardWidgetEventTimelineDefinition, DashboardWidgetEventTimelineDefinitionOutputReference, DashboardWidgetFreeTextDefinition, DashboardWidgetFreeTextDefinitionOutputReference, DashboardWidgetGeomapDefinition, DashboardWidgetGeomapDefinitionOutputReference } from './structs0';
import { DashboardWidgetGroupDefinition, DashboardWidgetGroupDefinitionOutputReference, DashboardWidgetHeatmapDefinition, DashboardWidgetHeatmapDefinitionOutputReference, DashboardWidgetHostmapDefinition, DashboardWidgetHostmapDefinitionOutputReference, DashboardWidgetIframeDefinition, DashboardWidgetIframeDefinitionOutputReference, DashboardWidgetImageDefinition, DashboardWidgetImageDefinitionOutputReference, DashboardWidgetListStreamDefinition, DashboardWidgetListStreamDefinitionOutputReference, DashboardWidgetLogStreamDefinition, DashboardWidgetLogStreamDefinitionOutputReference, DashboardWidgetManageStatusDefinition, DashboardWidgetManageStatusDefinitionOutputReference, DashboardWidgetNoteDefinition, DashboardWidgetNoteDefinitionOutputReference, DashboardWidgetPowerpackDefinition, DashboardWidgetPowerpackDefinitionOutputReference } from './structs3600';
import { DashboardWidgetQueryTableDefinition, DashboardWidgetQueryTableDefinitionOutputReference, DashboardWidgetQueryValueDefinition, DashboardWidgetQueryValueDefinitionOutputReference, DashboardWidgetRunWorkflowDefinition, DashboardWidgetRunWorkflowDefinitionOutputReference } from './structs4000';
import { DashboardWidgetScatterplotDefinition, DashboardWidgetScatterplotDefinitionOutputReference, DashboardWidgetServiceLevelObjectiveDefinition, DashboardWidgetServiceLevelObjectiveDefinitionOutputReference, DashboardWidgetServicemapDefinition, DashboardWidgetServicemapDefinitionOutputReference, DashboardWidgetSloListDefinition, DashboardWidgetSloListDefinitionOutputReference } from './structs4400';
import { DashboardWidgetSplitGraphDefinition, DashboardWidgetSplitGraphDefinitionOutputReference } from './structs5600';
export interface DashboardWidgetToplistDefinitionRequestRumQueryGroupBy {
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * The maximum number of items in the group.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#limit Dashboard#limit}
    */
    readonly limit?: number;
    /**
    * sort_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#sort_query Dashboard#sort_query}
    */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy | cdktf.IResolvable): any;
export declare function dashboardWidgetToplistDefinitionRequestRumQueryGroupByToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy | cdktf.IResolvable): any;
export declare class DashboardWidgetToplistDefinitionRequestRumQueryGroupByOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBy | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy | cdktf.IResolvable | undefined);
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _sortQuery;
    get sortQuery(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQueryOutputReference;
    putSortQuery(value: DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery): void;
    resetSortQuery(): void;
    get sortQueryInput(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery | undefined;
}
export declare class DashboardWidgetToplistDefinitionRequestRumQueryGroupByList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetToplistDefinitionRequestRumQueryGroupByOutputReference;
}
export interface DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute {
    /**
    * The aggregation method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * Define the time interval in seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#interval Dashboard#interval}
    */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute | cdktf.IResolvable): any;
export declare function dashboardWidgetToplistDefinitionRequestRumQueryMultiComputeToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute | cdktf.IResolvable): any;
export declare class DashboardWidgetToplistDefinitionRequestRumQueryMultiComputeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
}
export declare class DashboardWidgetToplistDefinitionRequestRumQueryMultiComputeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetToplistDefinitionRequestRumQueryMultiComputeOutputReference;
}
export interface DashboardWidgetToplistDefinitionRequestRumQuery {
    /**
    * The name of the index to query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#index Dashboard#index}
    */
    readonly index: string;
    /**
    * The search query to use.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#search_query Dashboard#search_query}
    */
    readonly searchQuery?: string;
    /**
    * compute_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#compute_query Dashboard#compute_query}
    */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery;
    /**
    * group_by block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_by Dashboard#group_by}
    */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[] | cdktf.IResolvable;
    /**
    * multi_compute block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#multi_compute Dashboard#multi_compute}
    */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[] | cdktf.IResolvable;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryOutputReference | DashboardWidgetToplistDefinitionRequestRumQuery): any;
export declare function dashboardWidgetToplistDefinitionRequestRumQueryToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryOutputReference | DashboardWidgetToplistDefinitionRequestRumQuery): any;
export declare class DashboardWidgetToplistDefinitionRequestRumQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQuery | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQuery | undefined);
    private _index?;
    get index(): string;
    set index(value: string);
    get indexInput(): string | undefined;
    private _searchQuery?;
    get searchQuery(): string;
    set searchQuery(value: string);
    resetSearchQuery(): void;
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    get computeQuery(): DashboardWidgetToplistDefinitionRequestRumQueryComputeQueryOutputReference;
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery): void;
    resetComputeQuery(): void;
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery | undefined;
    private _groupBy;
    get groupBy(): DashboardWidgetToplistDefinitionRequestRumQueryGroupByList;
    putGroupBy(value: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[] | cdktf.IResolvable): void;
    resetGroupBy(): void;
    get groupByInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[] | undefined;
    private _multiCompute;
    get multiCompute(): DashboardWidgetToplistDefinitionRequestRumQueryMultiComputeList;
    putMultiCompute(value: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[] | cdktf.IResolvable): void;
    resetMultiCompute(): void;
    get multiComputeInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[] | undefined;
}
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery {
    /**
    * The aggregation method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * Define the time interval in seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#interval Dashboard#interval}
    */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery): any;
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery): any;
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
}
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery {
    /**
    * The aggregation method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * Widget sorting methods. Valid values are `asc`, `desc`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#order Dashboard#order}
    */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery): any;
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery): any;
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _order?;
    get order(): string;
    set order(value: string);
    get orderInput(): string | undefined;
}
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy {
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * The maximum number of items in the group.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#limit Dashboard#limit}
    */
    readonly limit?: number;
    /**
    * sort_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#sort_query Dashboard#sort_query}
    */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy | cdktf.IResolvable): any;
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupByToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy | cdktf.IResolvable): any;
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryGroupByOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy | cdktf.IResolvable | undefined);
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _sortQuery;
    get sortQuery(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference;
    putSortQuery(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery): void;
    resetSortQuery(): void;
    get sortQueryInput(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery | undefined;
}
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryGroupByList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupByOutputReference;
}
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute {
    /**
    * The aggregation method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * The facet name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet?: string;
    /**
    * Define the time interval in seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#interval Dashboard#interval}
    */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute | cdktf.IResolvable): any;
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute | cdktf.IResolvable): any;
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _facet?;
    get facet(): string;
    set facet(value: string);
    resetFacet(): void;
    get facetInput(): string | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
}
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeOutputReference;
}
export interface DashboardWidgetToplistDefinitionRequestSecurityQuery {
    /**
    * The name of the index to query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#index Dashboard#index}
    */
    readonly index: string;
    /**
    * The search query to use.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#search_query Dashboard#search_query}
    */
    readonly searchQuery?: string;
    /**
    * compute_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#compute_query Dashboard#compute_query}
    */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery;
    /**
    * group_by block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_by Dashboard#group_by}
    */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[] | cdktf.IResolvable;
    /**
    * multi_compute block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#multi_compute Dashboard#multi_compute}
    */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[] | cdktf.IResolvable;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQuery): any;
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQuery): any;
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQuery | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQuery | undefined);
    private _index?;
    get index(): string;
    set index(value: string);
    get indexInput(): string | undefined;
    private _searchQuery?;
    get searchQuery(): string;
    set searchQuery(value: string);
    resetSearchQuery(): void;
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    get computeQuery(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference;
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery): void;
    resetComputeQuery(): void;
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined;
    private _groupBy;
    get groupBy(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupByList;
    putGroupBy(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[] | cdktf.IResolvable): void;
    resetGroupBy(): void;
    get groupByInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[] | undefined;
    private _multiCompute;
    get multiCompute(): DashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeList;
    putMultiCompute(value: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[] | cdktf.IResolvable): void;
    resetMultiCompute(): void;
    get multiComputeInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[] | undefined;
}
export interface DashboardWidgetToplistDefinitionRequestStyle {
    /**
    * A color palette to apply to the widget. The available options are available at: https://docs.datadoghq.com/dashboards/widgets/timeseries/#appearance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#palette Dashboard#palette}
    */
    readonly palette?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestStyleToTerraform(struct?: DashboardWidgetToplistDefinitionRequestStyleOutputReference | DashboardWidgetToplistDefinitionRequestStyle): any;
export declare function dashboardWidgetToplistDefinitionRequestStyleToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequestStyleOutputReference | DashboardWidgetToplistDefinitionRequestStyle): any;
export declare class DashboardWidgetToplistDefinitionRequestStyleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinitionRequestStyle | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequestStyle | undefined);
    private _palette?;
    get palette(): string;
    set palette(value: string);
    resetPalette(): void;
    get paletteInput(): string | undefined;
}
export interface DashboardWidgetToplistDefinitionRequest {
    /**
    * The metric query to use for this widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#q Dashboard#q}
    */
    readonly q?: string;
    /**
    * apm_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#apm_query Dashboard#apm_query}
    */
    readonly apmQuery?: DashboardWidgetToplistDefinitionRequestApmQuery;
    /**
    * audit_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#audit_query Dashboard#audit_query}
    */
    readonly auditQuery?: DashboardWidgetToplistDefinitionRequestAuditQuery;
    /**
    * conditional_formats block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#conditional_formats Dashboard#conditional_formats}
    */
    readonly conditionalFormats?: DashboardWidgetToplistDefinitionRequestConditionalFormats[] | cdktf.IResolvable;
    /**
    * formula block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#formula Dashboard#formula}
    */
    readonly formula?: DashboardWidgetToplistDefinitionRequestFormula[] | cdktf.IResolvable;
    /**
    * log_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#log_query Dashboard#log_query}
    */
    readonly logQuery?: DashboardWidgetToplistDefinitionRequestLogQuery;
    /**
    * process_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#process_query Dashboard#process_query}
    */
    readonly processQuery?: DashboardWidgetToplistDefinitionRequestProcessQuery;
    /**
    * query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query?: DashboardWidgetToplistDefinitionRequestQuery[] | cdktf.IResolvable;
    /**
    * rum_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#rum_query Dashboard#rum_query}
    */
    readonly rumQuery?: DashboardWidgetToplistDefinitionRequestRumQuery;
    /**
    * security_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#security_query Dashboard#security_query}
    */
    readonly securityQuery?: DashboardWidgetToplistDefinitionRequestSecurityQuery;
    /**
    * style block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#style Dashboard#style}
    */
    readonly style?: DashboardWidgetToplistDefinitionRequestStyle;
}
export declare function dashboardWidgetToplistDefinitionRequestToTerraform(struct?: DashboardWidgetToplistDefinitionRequest | cdktf.IResolvable): any;
export declare function dashboardWidgetToplistDefinitionRequestToHclTerraform(struct?: DashboardWidgetToplistDefinitionRequest | cdktf.IResolvable): any;
export declare class DashboardWidgetToplistDefinitionRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetToplistDefinitionRequest | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetToplistDefinitionRequest | cdktf.IResolvable | undefined);
    private _q?;
    get q(): string;
    set q(value: string);
    resetQ(): void;
    get qInput(): string | undefined;
    private _apmQuery;
    get apmQuery(): DashboardWidgetToplistDefinitionRequestApmQueryOutputReference;
    putApmQuery(value: DashboardWidgetToplistDefinitionRequestApmQuery): void;
    resetApmQuery(): void;
    get apmQueryInput(): DashboardWidgetToplistDefinitionRequestApmQuery | undefined;
    private _auditQuery;
    get auditQuery(): DashboardWidgetToplistDefinitionRequestAuditQueryOutputReference;
    putAuditQuery(value: DashboardWidgetToplistDefinitionRequestAuditQuery): void;
    resetAuditQuery(): void;
    get auditQueryInput(): DashboardWidgetToplistDefinitionRequestAuditQuery | undefined;
    private _conditionalFormats;
    get conditionalFormats(): DashboardWidgetToplistDefinitionRequestConditionalFormatsList;
    putConditionalFormats(value: DashboardWidgetToplistDefinitionRequestConditionalFormats[] | cdktf.IResolvable): void;
    resetConditionalFormats(): void;
    get conditionalFormatsInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestConditionalFormats[] | undefined;
    private _formula;
    get formula(): DashboardWidgetToplistDefinitionRequestFormulaList;
    putFormula(value: DashboardWidgetToplistDefinitionRequestFormula[] | cdktf.IResolvable): void;
    resetFormula(): void;
    get formulaInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestFormula[] | undefined;
    private _logQuery;
    get logQuery(): DashboardWidgetToplistDefinitionRequestLogQueryOutputReference;
    putLogQuery(value: DashboardWidgetToplistDefinitionRequestLogQuery): void;
    resetLogQuery(): void;
    get logQueryInput(): DashboardWidgetToplistDefinitionRequestLogQuery | undefined;
    private _processQuery;
    get processQuery(): DashboardWidgetToplistDefinitionRequestProcessQueryOutputReference;
    putProcessQuery(value: DashboardWidgetToplistDefinitionRequestProcessQuery): void;
    resetProcessQuery(): void;
    get processQueryInput(): DashboardWidgetToplistDefinitionRequestProcessQuery | undefined;
    private _query;
    get query(): DashboardWidgetToplistDefinitionRequestQueryList;
    putQuery(value: DashboardWidgetToplistDefinitionRequestQuery[] | cdktf.IResolvable): void;
    resetQuery(): void;
    get queryInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequestQuery[] | undefined;
    private _rumQuery;
    get rumQuery(): DashboardWidgetToplistDefinitionRequestRumQueryOutputReference;
    putRumQuery(value: DashboardWidgetToplistDefinitionRequestRumQuery): void;
    resetRumQuery(): void;
    get rumQueryInput(): DashboardWidgetToplistDefinitionRequestRumQuery | undefined;
    private _securityQuery;
    get securityQuery(): DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference;
    putSecurityQuery(value: DashboardWidgetToplistDefinitionRequestSecurityQuery): void;
    resetSecurityQuery(): void;
    get securityQueryInput(): DashboardWidgetToplistDefinitionRequestSecurityQuery | undefined;
    private _style;
    get style(): DashboardWidgetToplistDefinitionRequestStyleOutputReference;
    putStyle(value: DashboardWidgetToplistDefinitionRequestStyle): void;
    resetStyle(): void;
    get styleInput(): DashboardWidgetToplistDefinitionRequestStyle | undefined;
}
export declare class DashboardWidgetToplistDefinitionRequestList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetToplistDefinitionRequest[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetToplistDefinitionRequestOutputReference;
}
export interface DashboardWidgetToplistDefinition {
    /**
    * The timeframe to use when displaying the widget. Valid values are `1m`, `5m`, `10m`, `15m`, `30m`, `1h`, `4h`, `1d`, `2d`, `1w`, `1mo`, `3mo`, `6mo`, `week_to_date`, `month_to_date`, `1y`, `alert`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#live_span Dashboard#live_span}
    */
    readonly liveSpan?: string;
    /**
    * The title of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title Dashboard#title}
    */
    readonly title?: string;
    /**
    * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_align Dashboard#title_align}
    */
    readonly titleAlign?: string;
    /**
    * The size of the widget's title (defaults to 16).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_size Dashboard#title_size}
    */
    readonly titleSize?: string;
    /**
    * custom_link block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#custom_link Dashboard#custom_link}
    */
    readonly customLink?: DashboardWidgetToplistDefinitionCustomLink[] | cdktf.IResolvable;
    /**
    * request block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#request Dashboard#request}
    */
    readonly request?: DashboardWidgetToplistDefinitionRequest[] | cdktf.IResolvable;
}
export declare function dashboardWidgetToplistDefinitionToTerraform(struct?: DashboardWidgetToplistDefinitionOutputReference | DashboardWidgetToplistDefinition): any;
export declare function dashboardWidgetToplistDefinitionToHclTerraform(struct?: DashboardWidgetToplistDefinitionOutputReference | DashboardWidgetToplistDefinition): any;
export declare class DashboardWidgetToplistDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetToplistDefinition | undefined;
    set internalValue(value: DashboardWidgetToplistDefinition | undefined);
    private _liveSpan?;
    get liveSpan(): string;
    set liveSpan(value: string);
    resetLiveSpan(): void;
    get liveSpanInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _titleAlign?;
    get titleAlign(): string;
    set titleAlign(value: string);
    resetTitleAlign(): void;
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    get titleSize(): string;
    set titleSize(value: string);
    resetTitleSize(): void;
    get titleSizeInput(): string | undefined;
    private _customLink;
    get customLink(): DashboardWidgetToplistDefinitionCustomLinkList;
    putCustomLink(value: DashboardWidgetToplistDefinitionCustomLink[] | cdktf.IResolvable): void;
    resetCustomLink(): void;
    get customLinkInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionCustomLink[] | undefined;
    private _request;
    get request(): DashboardWidgetToplistDefinitionRequestList;
    putRequest(value: DashboardWidgetToplistDefinitionRequest[] | cdktf.IResolvable): void;
    resetRequest(): void;
    get requestInput(): cdktf.IResolvable | DashboardWidgetToplistDefinitionRequest[] | undefined;
}
export interface DashboardWidgetTopologyMapDefinitionCustomLink {
    /**
    * The flag for toggling context menu link visibility.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#is_hidden Dashboard#is_hidden}
    */
    readonly isHidden?: boolean | cdktf.IResolvable;
    /**
    * The label for the custom link URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#label Dashboard#label}
    */
    readonly label?: string;
    /**
    * The URL of the custom link.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#link Dashboard#link}
    */
    readonly link?: string;
    /**
    * The label ID that refers to a context menu link item. When `override_label` is provided, the client request omits the label field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#override_label Dashboard#override_label}
    */
    readonly overrideLabel?: string;
}
export declare function dashboardWidgetTopologyMapDefinitionCustomLinkToTerraform(struct?: DashboardWidgetTopologyMapDefinitionCustomLink | cdktf.IResolvable): any;
export declare function dashboardWidgetTopologyMapDefinitionCustomLinkToHclTerraform(struct?: DashboardWidgetTopologyMapDefinitionCustomLink | cdktf.IResolvable): any;
export declare class DashboardWidgetTopologyMapDefinitionCustomLinkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTopologyMapDefinitionCustomLink | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTopologyMapDefinitionCustomLink | cdktf.IResolvable | undefined);
    private _isHidden?;
    get isHidden(): boolean | cdktf.IResolvable;
    set isHidden(value: boolean | cdktf.IResolvable);
    resetIsHidden(): void;
    get isHiddenInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _link?;
    get link(): string;
    set link(value: string);
    resetLink(): void;
    get linkInput(): string | undefined;
    private _overrideLabel?;
    get overrideLabel(): string;
    set overrideLabel(value: string);
    resetOverrideLabel(): void;
    get overrideLabelInput(): string | undefined;
}
export declare class DashboardWidgetTopologyMapDefinitionCustomLinkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTopologyMapDefinitionCustomLink[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTopologyMapDefinitionCustomLinkOutputReference;
}
export interface DashboardWidgetTopologyMapDefinitionRequestQuery {
    /**
    * The data source for the Topology request ('service_map' or 'data_streams'). Valid values are `data_streams`, `service_map`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * Your environment and primary tag (or `*` if enabled for your account).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#filters Dashboard#filters}
    */
    readonly filters: string[];
    /**
    * The ID of the service to map.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#service Dashboard#service}
    */
    readonly service: string;
}
export declare function dashboardWidgetTopologyMapDefinitionRequestQueryToTerraform(struct?: DashboardWidgetTopologyMapDefinitionRequestQuery | cdktf.IResolvable): any;
export declare function dashboardWidgetTopologyMapDefinitionRequestQueryToHclTerraform(struct?: DashboardWidgetTopologyMapDefinitionRequestQuery | cdktf.IResolvable): any;
export declare class DashboardWidgetTopologyMapDefinitionRequestQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTopologyMapDefinitionRequestQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTopologyMapDefinitionRequestQuery | cdktf.IResolvable | undefined);
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _filters?;
    get filters(): string[];
    set filters(value: string[]);
    get filtersInput(): string[] | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
}
export declare class DashboardWidgetTopologyMapDefinitionRequestQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTopologyMapDefinitionRequestQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTopologyMapDefinitionRequestQueryOutputReference;
}
export interface DashboardWidgetTopologyMapDefinitionRequest {
    /**
    * The request type for the Topology request ('topology'). Valid values are `topology`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#request_type Dashboard#request_type}
    */
    readonly requestType: string;
    /**
    * query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query: DashboardWidgetTopologyMapDefinitionRequestQuery[] | cdktf.IResolvable;
}
export declare function dashboardWidgetTopologyMapDefinitionRequestToTerraform(struct?: DashboardWidgetTopologyMapDefinitionRequest | cdktf.IResolvable): any;
export declare function dashboardWidgetTopologyMapDefinitionRequestToHclTerraform(struct?: DashboardWidgetTopologyMapDefinitionRequest | cdktf.IResolvable): any;
export declare class DashboardWidgetTopologyMapDefinitionRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTopologyMapDefinitionRequest | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTopologyMapDefinitionRequest | cdktf.IResolvable | undefined);
    private _requestType?;
    get requestType(): string;
    set requestType(value: string);
    get requestTypeInput(): string | undefined;
    private _query;
    get query(): DashboardWidgetTopologyMapDefinitionRequestQueryList;
    putQuery(value: DashboardWidgetTopologyMapDefinitionRequestQuery[] | cdktf.IResolvable): void;
    get queryInput(): cdktf.IResolvable | DashboardWidgetTopologyMapDefinitionRequestQuery[] | undefined;
}
export declare class DashboardWidgetTopologyMapDefinitionRequestList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTopologyMapDefinitionRequest[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTopologyMapDefinitionRequestOutputReference;
}
export interface DashboardWidgetTopologyMapDefinition {
    /**
    * The title of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title Dashboard#title}
    */
    readonly title?: string;
    /**
    * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_align Dashboard#title_align}
    */
    readonly titleAlign?: string;
    /**
    * The size of the widget's title (defaults to 16).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_size Dashboard#title_size}
    */
    readonly titleSize?: string;
    /**
    * custom_link block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#custom_link Dashboard#custom_link}
    */
    readonly customLink?: DashboardWidgetTopologyMapDefinitionCustomLink[] | cdktf.IResolvable;
    /**
    * request block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#request Dashboard#request}
    */
    readonly request?: DashboardWidgetTopologyMapDefinitionRequest[] | cdktf.IResolvable;
}
export declare function dashboardWidgetTopologyMapDefinitionToTerraform(struct?: DashboardWidgetTopologyMapDefinitionOutputReference | DashboardWidgetTopologyMapDefinition): any;
export declare function dashboardWidgetTopologyMapDefinitionToHclTerraform(struct?: DashboardWidgetTopologyMapDefinitionOutputReference | DashboardWidgetTopologyMapDefinition): any;
export declare class DashboardWidgetTopologyMapDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTopologyMapDefinition | undefined;
    set internalValue(value: DashboardWidgetTopologyMapDefinition | undefined);
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _titleAlign?;
    get titleAlign(): string;
    set titleAlign(value: string);
    resetTitleAlign(): void;
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    get titleSize(): string;
    set titleSize(value: string);
    resetTitleSize(): void;
    get titleSizeInput(): string | undefined;
    private _customLink;
    get customLink(): DashboardWidgetTopologyMapDefinitionCustomLinkList;
    putCustomLink(value: DashboardWidgetTopologyMapDefinitionCustomLink[] | cdktf.IResolvable): void;
    resetCustomLink(): void;
    get customLinkInput(): cdktf.IResolvable | DashboardWidgetTopologyMapDefinitionCustomLink[] | undefined;
    private _request;
    get request(): DashboardWidgetTopologyMapDefinitionRequestList;
    putRequest(value: DashboardWidgetTopologyMapDefinitionRequest[] | cdktf.IResolvable): void;
    resetRequest(): void;
    get requestInput(): cdktf.IResolvable | DashboardWidgetTopologyMapDefinitionRequest[] | undefined;
}
export interface DashboardWidgetTraceServiceDefinition {
    /**
    * The number of columns to display. Valid values are `one_column`, `two_column`, `three_column`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#display_format Dashboard#display_format}
    */
    readonly displayFormat?: string;
    /**
    * APM environment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#env Dashboard#env}
    */
    readonly env: string;
    /**
    * The timeframe to use when displaying the widget. Valid values are `1m`, `5m`, `10m`, `15m`, `30m`, `1h`, `4h`, `1d`, `2d`, `1w`, `1mo`, `3mo`, `6mo`, `week_to_date`, `month_to_date`, `1y`, `alert`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#live_span Dashboard#live_span}
    */
    readonly liveSpan?: string;
    /**
    * APM service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#service Dashboard#service}
    */
    readonly service: string;
    /**
    * Whether to show the latency breakdown or not.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_breakdown Dashboard#show_breakdown}
    */
    readonly showBreakdown?: boolean | cdktf.IResolvable;
    /**
    * Whether to show the latency distribution or not.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_distribution Dashboard#show_distribution}
    */
    readonly showDistribution?: boolean | cdktf.IResolvable;
    /**
    * Whether to show the error metrics or not.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_errors Dashboard#show_errors}
    */
    readonly showErrors?: boolean | cdktf.IResolvable;
    /**
    * Whether to show the hits metrics or not
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_hits Dashboard#show_hits}
    */
    readonly showHits?: boolean | cdktf.IResolvable;
    /**
    * Whether to show the latency metrics or not.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_latency Dashboard#show_latency}
    */
    readonly showLatency?: boolean | cdktf.IResolvable;
    /**
    * Whether to show the resource list or not.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#show_resource_list Dashboard#show_resource_list}
    */
    readonly showResourceList?: boolean | cdktf.IResolvable;
    /**
    * The size of the widget. Valid values are `small`, `medium`, `large`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#size_format Dashboard#size_format}
    */
    readonly sizeFormat?: string;
    /**
    * APM span name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#span_name Dashboard#span_name}
    */
    readonly spanName: string;
    /**
    * The title of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title Dashboard#title}
    */
    readonly title?: string;
    /**
    * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_align Dashboard#title_align}
    */
    readonly titleAlign?: string;
    /**
    * The size of the widget's title (defaults to 16).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title_size Dashboard#title_size}
    */
    readonly titleSize?: string;
}
export declare function dashboardWidgetTraceServiceDefinitionToTerraform(struct?: DashboardWidgetTraceServiceDefinitionOutputReference | DashboardWidgetTraceServiceDefinition): any;
export declare function dashboardWidgetTraceServiceDefinitionToHclTerraform(struct?: DashboardWidgetTraceServiceDefinitionOutputReference | DashboardWidgetTraceServiceDefinition): any;
export declare class DashboardWidgetTraceServiceDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTraceServiceDefinition | undefined;
    set internalValue(value: DashboardWidgetTraceServiceDefinition | undefined);
    private _displayFormat?;
    get displayFormat(): string;
    set displayFormat(value: string);
    resetDisplayFormat(): void;
    get displayFormatInput(): string | undefined;
    private _env?;
    get env(): string;
    set env(value: string);
    get envInput(): string | undefined;
    private _liveSpan?;
    get liveSpan(): string;
    set liveSpan(value: string);
    resetLiveSpan(): void;
    get liveSpanInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
    private _showBreakdown?;
    get showBreakdown(): boolean | cdktf.IResolvable;
    set showBreakdown(value: boolean | cdktf.IResolvable);
    resetShowBreakdown(): void;
    get showBreakdownInput(): boolean | cdktf.IResolvable | undefined;
    private _showDistribution?;
    get showDistribution(): boolean | cdktf.IResolvable;
    set showDistribution(value: boolean | cdktf.IResolvable);
    resetShowDistribution(): void;
    get showDistributionInput(): boolean | cdktf.IResolvable | undefined;
    private _showErrors?;
    get showErrors(): boolean | cdktf.IResolvable;
    set showErrors(value: boolean | cdktf.IResolvable);
    resetShowErrors(): void;
    get showErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _showHits?;
    get showHits(): boolean | cdktf.IResolvable;
    set showHits(value: boolean | cdktf.IResolvable);
    resetShowHits(): void;
    get showHitsInput(): boolean | cdktf.IResolvable | undefined;
    private _showLatency?;
    get showLatency(): boolean | cdktf.IResolvable;
    set showLatency(value: boolean | cdktf.IResolvable);
    resetShowLatency(): void;
    get showLatencyInput(): boolean | cdktf.IResolvable | undefined;
    private _showResourceList?;
    get showResourceList(): boolean | cdktf.IResolvable;
    set showResourceList(value: boolean | cdktf.IResolvable);
    resetShowResourceList(): void;
    get showResourceListInput(): boolean | cdktf.IResolvable | undefined;
    private _sizeFormat?;
    get sizeFormat(): string;
    set sizeFormat(value: string);
    resetSizeFormat(): void;
    get sizeFormatInput(): string | undefined;
    private _spanName?;
    get spanName(): string;
    set spanName(value: string);
    get spanNameInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _titleAlign?;
    get titleAlign(): string;
    set titleAlign(value: string);
    resetTitleAlign(): void;
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    get titleSize(): string;
    set titleSize(value: string);
    resetTitleSize(): void;
    get titleSizeInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats {
    /**
    * The comparator to use. Valid values are `=`, `>`, `>=`, `<`, `<=`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#comparator Dashboard#comparator}
    */
    readonly comparator: string;
    /**
    * The color palette to apply to the background, same values available as palette.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#custom_bg_color Dashboard#custom_bg_color}
    */
    readonly customBgColor?: string;
    /**
    * The color palette to apply to the foreground, same values available as palette.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#custom_fg_color Dashboard#custom_fg_color}
    */
    readonly customFgColor?: string;
    /**
    * Setting this to True hides values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#hide_value Dashboard#hide_value}
    */
    readonly hideValue?: boolean | cdktf.IResolvable;
    /**
    * Displays an image as the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#image_url Dashboard#image_url}
    */
    readonly imageUrl?: string;
    /**
    * The metric from the request to correlate with this conditional format.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#metric Dashboard#metric}
    */
    readonly metric?: string;
    /**
    * The color palette to apply. Valid values are `blue`, `custom_bg`, `custom_image`, `custom_text`, `gray_on_white`, `grey`, `green`, `orange`, `red`, `red_on_white`, `white_on_gray`, `white_on_green`, `green_on_white`, `white_on_red`, `white_on_yellow`, `yellow_on_white`, `black_on_light_yellow`, `black_on_light_green`, `black_on_light_red`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#palette Dashboard#palette}
    */
    readonly palette: string;
    /**
    * Defines the displayed timeframe.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#timeframe Dashboard#timeframe}
    */
    readonly timeframe?: string;
    /**
    * A value for the comparator.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#value Dashboard#value}
    */
    readonly value: number;
}
export declare function dashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats | cdktf.IResolvable | undefined);
    private _comparator?;
    get comparator(): string;
    set comparator(value: string);
    get comparatorInput(): string | undefined;
    private _customBgColor?;
    get customBgColor(): string;
    set customBgColor(value: string);
    resetCustomBgColor(): void;
    get customBgColorInput(): string | undefined;
    private _customFgColor?;
    get customFgColor(): string;
    set customFgColor(value: string);
    resetCustomFgColor(): void;
    get customFgColorInput(): string | undefined;
    private _hideValue?;
    get hideValue(): boolean | cdktf.IResolvable;
    set hideValue(value: boolean | cdktf.IResolvable);
    resetHideValue(): void;
    get hideValueInput(): boolean | cdktf.IResolvable | undefined;
    private _imageUrl?;
    get imageUrl(): string;
    set imageUrl(value: string);
    resetImageUrl(): void;
    get imageUrlInput(): string | undefined;
    private _metric?;
    get metric(): string;
    set metric(value: string);
    resetMetric(): void;
    get metricInput(): string | undefined;
    private _palette?;
    get palette(): string;
    set palette(value: string);
    get paletteInput(): string | undefined;
    private _timeframe?;
    get timeframe(): string;
    set timeframe(value: string);
    resetTimeframe(): void;
    get timeframeInput(): string | undefined;
    private _value?;
    get value(): number;
    set value(value: number);
    get valueInput(): number | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsOutputReference;
}
export interface DashboardWidgetTreemapDefinitionRequestFormulaLimit {
    /**
    * The number of results to return.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#count Dashboard#count}
    */
    readonly count?: number;
    /**
    * The direction of the sort. Valid values are `asc`, `desc`. Defaults to `"desc"`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#order Dashboard#order}
    */
    readonly order?: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestFormulaLimitToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaLimitOutputReference | DashboardWidgetTreemapDefinitionRequestFormulaLimit): any;
export declare function dashboardWidgetTreemapDefinitionRequestFormulaLimitToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaLimitOutputReference | DashboardWidgetTreemapDefinitionRequestFormulaLimit): any;
export declare class DashboardWidgetTreemapDefinitionRequestFormulaLimitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestFormulaLimit | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestFormulaLimit | undefined);
    private _count?;
    get count(): number;
    set count(value: number);
    resetCount(): void;
    get countInput(): number | undefined;
    private _order?;
    get order(): string;
    set order(value: string);
    resetOrder(): void;
    get orderInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestFormulaStyle {
    /**
    * The color palette used to display the formula. A guide to the available color palettes can be found at https://docs.datadoghq.com/dashboards/guide/widget_colors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#palette Dashboard#palette}
    */
    readonly palette?: string;
    /**
    * Index specifying which color to use within the palette.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#palette_index Dashboard#palette_index}
    */
    readonly paletteIndex?: number;
}
export declare function dashboardWidgetTreemapDefinitionRequestFormulaStyleToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaStyleOutputReference | DashboardWidgetTreemapDefinitionRequestFormulaStyle): any;
export declare function dashboardWidgetTreemapDefinitionRequestFormulaStyleToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormulaStyleOutputReference | DashboardWidgetTreemapDefinitionRequestFormulaStyle): any;
export declare class DashboardWidgetTreemapDefinitionRequestFormulaStyleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestFormulaStyle | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestFormulaStyle | undefined);
    private _palette?;
    get palette(): string;
    set palette(value: string);
    resetPalette(): void;
    get paletteInput(): string | undefined;
    private _paletteIndex?;
    get paletteIndex(): number;
    set paletteIndex(value: number);
    resetPaletteIndex(): void;
    get paletteIndexInput(): number | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestFormula {
    /**
    * An expression alias.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#alias Dashboard#alias}
    */
    readonly alias?: string;
    /**
    * A list of display modes for each table cell. Valid values are `number`, `bar`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cell_display_mode Dashboard#cell_display_mode}
    */
    readonly cellDisplayMode?: string;
    /**
    * A string expression built from queries, formulas, and functions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#formula_expression Dashboard#formula_expression}
    */
    readonly formulaExpression: string;
    /**
    * conditional_formats block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#conditional_formats Dashboard#conditional_formats}
    */
    readonly conditionalFormats?: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats[] | cdktf.IResolvable;
    /**
    * limit block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#limit Dashboard#limit}
    */
    readonly limit?: DashboardWidgetTreemapDefinitionRequestFormulaLimit;
    /**
    * style block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#style Dashboard#style}
    */
    readonly style?: DashboardWidgetTreemapDefinitionRequestFormulaStyle;
}
export declare function dashboardWidgetTreemapDefinitionRequestFormulaToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormula | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestFormulaToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestFormula | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestFormulaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestFormula | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestFormula | cdktf.IResolvable | undefined);
    private _alias?;
    get alias(): string;
    set alias(value: string);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    private _cellDisplayMode?;
    get cellDisplayMode(): string;
    set cellDisplayMode(value: string);
    resetCellDisplayMode(): void;
    get cellDisplayModeInput(): string | undefined;
    private _formulaExpression?;
    get formulaExpression(): string;
    set formulaExpression(value: string);
    get formulaExpressionInput(): string | undefined;
    private _conditionalFormats;
    get conditionalFormats(): DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormatsList;
    putConditionalFormats(value: DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats[] | cdktf.IResolvable): void;
    resetConditionalFormats(): void;
    get conditionalFormatsInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequestFormulaConditionalFormats[] | undefined;
    private _limit;
    get limit(): DashboardWidgetTreemapDefinitionRequestFormulaLimitOutputReference;
    putLimit(value: DashboardWidgetTreemapDefinitionRequestFormulaLimit): void;
    resetLimit(): void;
    get limitInput(): DashboardWidgetTreemapDefinitionRequestFormulaLimit | undefined;
    private _style;
    get style(): DashboardWidgetTreemapDefinitionRequestFormulaStyleOutputReference;
    putStyle(value: DashboardWidgetTreemapDefinitionRequestFormulaStyle): void;
    resetStyle(): void;
    get styleInput(): DashboardWidgetTreemapDefinitionRequestFormulaStyle | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestFormulaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequestFormula[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestFormulaOutputReference;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery {
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for APM Dependency Stats queries. Valid values are `apm_dependency_stats`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * APM environment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#env Dashboard#env}
    */
    readonly env: string;
    /**
    * Determines whether stats for upstream or downstream dependencies should be queried.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#is_upstream Dashboard#is_upstream}
    */
    readonly isUpstream?: boolean | cdktf.IResolvable;
    /**
    * The name of query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * Name of operation on service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#operation_name Dashboard#operation_name}
    */
    readonly operationName: string;
    /**
    * The name of the second primary tag used within APM; required when `primary_tag_value` is specified. See https://docs.datadoghq.com/tracing/guide/setting_primary_tags_to_scope/#add-a-second-primary-tag-in-datadog.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#primary_tag_name Dashboard#primary_tag_name}
    */
    readonly primaryTagName?: string;
    /**
    * Filter APM data by the second primary tag. `primary_tag_name` must also be specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#primary_tag_value Dashboard#primary_tag_value}
    */
    readonly primaryTagValue?: string;
    /**
    * APM resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#resource_name Dashboard#resource_name}
    */
    readonly resourceName: string;
    /**
    * APM service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#service Dashboard#service}
    */
    readonly service: string;
    /**
    * APM statistic. Valid values are `avg_duration`, `avg_root_duration`, `avg_spans_per_trace`, `error_rate`, `pct_exec_time`, `pct_of_traces`, `total_traces_count`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#stat Dashboard#stat}
    */
    readonly stat: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery | undefined);
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _env?;
    get env(): string;
    set env(value: string);
    get envInput(): string | undefined;
    private _isUpstream?;
    get isUpstream(): boolean | cdktf.IResolvable;
    set isUpstream(value: boolean | cdktf.IResolvable);
    resetIsUpstream(): void;
    get isUpstreamInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _operationName?;
    get operationName(): string;
    set operationName(value: string);
    get operationNameInput(): string | undefined;
    private _primaryTagName?;
    get primaryTagName(): string;
    set primaryTagName(value: string);
    resetPrimaryTagName(): void;
    get primaryTagNameInput(): string | undefined;
    private _primaryTagValue?;
    get primaryTagValue(): string;
    set primaryTagValue(value: string);
    resetPrimaryTagValue(): void;
    get primaryTagValueInput(): string | undefined;
    private _resourceName?;
    get resourceName(): string;
    set resourceName(value: string);
    get resourceNameInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
    private _stat?;
    get stat(): string;
    set stat(value: string);
    get statInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery {
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for APM Resource Stats queries. Valid values are `apm_resource_stats`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * APM environment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#env Dashboard#env}
    */
    readonly env: string;
    /**
    * Array of fields to group results by.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_by Dashboard#group_by}
    */
    readonly groupBy?: string[];
    /**
    * The name of query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * Name of operation on service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#operation_name Dashboard#operation_name}
    */
    readonly operationName?: string;
    /**
    * The name of the second primary tag used within APM; required when `primary_tag_value` is specified. See https://docs.datadoghq.com/tracing/guide/setting_primary_tags_to_scope/#add-a-second-primary-tag-in-datadog.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#primary_tag_name Dashboard#primary_tag_name}
    */
    readonly primaryTagName?: string;
    /**
    * Filter APM data by the second primary tag. `primary_tag_name` must also be specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#primary_tag_value Dashboard#primary_tag_value}
    */
    readonly primaryTagValue?: string;
    /**
    * APM resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#resource_name Dashboard#resource_name}
    */
    readonly resourceName?: string;
    /**
    * APM service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#service Dashboard#service}
    */
    readonly service: string;
    /**
    * APM statistic. Valid values are `errors`, `error_rate`, `hits`, `latency_avg`, `latency_distribution`, `latency_max`, `latency_p50`, `latency_p75`, `latency_p90`, `latency_p95`, `latency_p99`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#stat Dashboard#stat}
    */
    readonly stat: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery | undefined);
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _env?;
    get env(): string;
    set env(value: string);
    get envInput(): string | undefined;
    private _groupBy?;
    get groupBy(): string[];
    set groupBy(value: string[]);
    resetGroupBy(): void;
    get groupByInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _operationName?;
    get operationName(): string;
    set operationName(value: string);
    resetOperationName(): void;
    get operationNameInput(): string | undefined;
    private _primaryTagName?;
    get primaryTagName(): string;
    set primaryTagName(value: string);
    resetPrimaryTagName(): void;
    get primaryTagNameInput(): string | undefined;
    private _primaryTagValue?;
    get primaryTagValue(): string;
    set primaryTagValue(value: string);
    resetPrimaryTagValue(): void;
    get primaryTagValueInput(): string | undefined;
    private _resourceName?;
    get resourceName(): string;
    set resourceName(value: string);
    resetResourceName(): void;
    get resourceNameInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
    private _stat?;
    get stat(): string;
    set stat(value: string);
    get statInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery {
    /**
    * The aggregation methods available for cloud cost queries. Valid values are `avg`, `last`, `max`, `min`, `sum`, `percentile`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregator Dashboard#aggregator}
    */
    readonly aggregator?: string;
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for cloud cost queries. Valid values are `cloud_cost`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * The name of the query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * The cloud cost query definition.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery | undefined);
    private _aggregator?;
    get aggregator(): string;
    set aggregator(value: string);
    resetAggregator(): void;
    get aggregatorInput(): string | undefined;
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute {
    /**
    * The aggregation methods for event platform queries. Valid values are `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * A time interval in milliseconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#interval Dashboard#interval}
    */
    readonly interval?: number;
    /**
    * The measurable attribute to compute.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#metric Dashboard#metric}
    */
    readonly metric?: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute | cdktf.IResolvable | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
    private _metric?;
    get metric(): string;
    set metric(value: string);
    resetMetric(): void;
    get metricInput(): string | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeOutputReference;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort {
    /**
    * The aggregation methods for the event platform queries. Valid values are `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregation Dashboard#aggregation}
    */
    readonly aggregation: string;
    /**
    * The metric used for sorting group by results.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#metric Dashboard#metric}
    */
    readonly metric?: string;
    /**
    * Direction of sort. Valid values are `asc`, `desc`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#order Dashboard#order}
    */
    readonly order?: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort | undefined);
    private _aggregation?;
    get aggregation(): string;
    set aggregation(value: string);
    get aggregationInput(): string | undefined;
    private _metric?;
    get metric(): string;
    set metric(value: string);
    resetMetric(): void;
    get metricInput(): string | undefined;
    private _order?;
    get order(): string;
    set order(value: string);
    resetOrder(): void;
    get orderInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy {
    /**
    * The event facet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#facet Dashboard#facet}
    */
    readonly facet: string;
    /**
    * The number of groups to return.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#limit Dashboard#limit}
    */
    readonly limit?: number;
    /**
    * sort block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#sort Dashboard#sort}
    */
    readonly sort?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy | cdktf.IResolvable | undefined);
    private _facet?;
    get facet(): string;
    set facet(value: string);
    get facetInput(): string | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _sort;
    get sort(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySortOutputReference;
    putSort(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort): void;
    resetSort(): void;
    get sortInput(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBySort | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByOutputReference;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch {
    /**
    * The events search string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch | undefined);
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryEventQuery {
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for event platform-based queries. Valid values are `logs`, `spans`, `network`, `rum`, `security_signals`, `profiles`, `audit`, `events`, `ci_tests`, `ci_pipelines`, `incident_analytics`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * An array of index names to query in the stream.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#indexes Dashboard#indexes}
    */
    readonly indexes?: string[];
    /**
    * The name of query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * Storage location (private beta).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#storage Dashboard#storage}
    */
    readonly storage?: string;
    /**
    * compute block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#compute Dashboard#compute}
    */
    readonly compute: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute[] | cdktf.IResolvable;
    /**
    * group_by block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_by Dashboard#group_by}
    */
    readonly groupBy?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy[] | cdktf.IResolvable;
    /**
    * search block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#search Dashboard#search}
    */
    readonly search?: DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryEventQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryEventQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryEventQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryEventQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryEventQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryEventQuery | undefined);
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _indexes?;
    get indexes(): string[];
    set indexes(value: string[]);
    resetIndexes(): void;
    get indexesInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _storage?;
    get storage(): string;
    set storage(value: string);
    resetStorage(): void;
    get storageInput(): string | undefined;
    private _compute;
    get compute(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryComputeList;
    putCompute(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute[] | cdktf.IResolvable): void;
    get computeInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequestQueryEventQueryCompute[] | undefined;
    private _groupBy;
    get groupBy(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupByList;
    putGroupBy(value: DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy[] | cdktf.IResolvable): void;
    resetGroupBy(): void;
    get groupByInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequestQueryEventQueryGroupBy[] | undefined;
    private _search;
    get search(): DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearchOutputReference;
    putSearch(value: DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch): void;
    resetSearch(): void;
    get searchInput(): DashboardWidgetTreemapDefinitionRequestQueryEventQuerySearch | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryMetricQuery {
    /**
    * The aggregation methods available for metrics queries. Valid values are `avg`, `min`, `max`, `sum`, `last`, `area`, `l2norm`, `percentile`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregator Dashboard#aggregator}
    */
    readonly aggregator?: string;
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for metrics queries. Defaults to `"metrics"`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource?: string;
    /**
    * The name of the query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * The metrics query definition.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryMetricQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryMetricQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryMetricQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryMetricQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryMetricQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryMetricQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryMetricQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryMetricQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryMetricQuery | undefined);
    private _aggregator?;
    get aggregator(): string;
    set aggregator(value: string);
    resetAggregator(): void;
    get aggregatorInput(): string | undefined;
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    resetDataSource(): void;
    get dataSourceInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQueryProcessQuery {
    /**
    * The aggregation methods available for metrics queries. Valid values are `avg`, `min`, `max`, `sum`, `last`, `area`, `l2norm`, `percentile`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#aggregator Dashboard#aggregator}
    */
    readonly aggregator?: string;
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for process queries. Valid values are `process`, `container`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * Whether to normalize the CPU percentages.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#is_normalized_cpu Dashboard#is_normalized_cpu}
    */
    readonly isNormalizedCpu?: boolean | cdktf.IResolvable;
    /**
    * The number of hits to return.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#limit Dashboard#limit}
    */
    readonly limit?: number;
    /**
    * The process metric name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#metric Dashboard#metric}
    */
    readonly metric: string;
    /**
    * The name of query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name: string;
    /**
    * The direction of the sort. Valid values are `asc`, `desc`. Defaults to `"desc"`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#sort Dashboard#sort}
    */
    readonly sort?: string;
    /**
    * An array of tags to filter by.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#tag_filters Dashboard#tag_filters}
    */
    readonly tagFilters?: string[];
    /**
    * The text to use as a filter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#text_filter Dashboard#text_filter}
    */
    readonly textFilter?: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryProcessQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryProcessQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryProcessQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryProcessQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQueryProcessQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQueryProcessQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryProcessQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQueryProcessQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQueryProcessQuery | undefined);
    private _aggregator?;
    get aggregator(): string;
    set aggregator(value: string);
    resetAggregator(): void;
    get aggregatorInput(): string | undefined;
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _isNormalizedCpu?;
    get isNormalizedCpu(): boolean | cdktf.IResolvable;
    set isNormalizedCpu(value: boolean | cdktf.IResolvable);
    resetIsNormalizedCpu(): void;
    get isNormalizedCpuInput(): boolean | cdktf.IResolvable | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _metric?;
    get metric(): string;
    set metric(value: string);
    get metricInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _sort?;
    get sort(): string;
    set sort(value: string);
    resetSort(): void;
    get sortInput(): string | undefined;
    private _tagFilters?;
    get tagFilters(): string[];
    set tagFilters(value: string[]);
    resetTagFilters(): void;
    get tagFiltersInput(): string[] | undefined;
    private _textFilter?;
    get textFilter(): string;
    set textFilter(value: string);
    resetTextFilter(): void;
    get textFilterInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQuerySloQuery {
    /**
    * Additional filters applied to the SLO query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#additional_query_filters Dashboard#additional_query_filters}
    */
    readonly additionalQueryFilters?: string;
    /**
    * The source organization UUID for cross organization queries. Feature in Private Beta.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cross_org_uuids Dashboard#cross_org_uuids}
    */
    readonly crossOrgUuids?: string[];
    /**
    * The data source for SLO queries. Valid values are `slo`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#data_source Dashboard#data_source}
    */
    readonly dataSource: string;
    /**
    * Group mode to query measures. Valid values are `overall`, `components`. Defaults to `"overall"`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_mode Dashboard#group_mode}
    */
    readonly groupMode?: string;
    /**
    * SLO measures queries. Valid values are `good_events`, `bad_events`, `slo_status`, `error_budget_remaining`, `burn_rate`, `error_budget_burndown`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#measure Dashboard#measure}
    */
    readonly measure: string;
    /**
    * The name of query for use in formulas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#name Dashboard#name}
    */
    readonly name?: string;
    /**
    * ID of an SLO to query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#slo_id Dashboard#slo_id}
    */
    readonly sloId: string;
    /**
    * type of the SLO to query. Valid values are `metric`, `time_slice`. Defaults to `"metric"`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#slo_query_type Dashboard#slo_query_type}
    */
    readonly sloQueryType?: string;
}
export declare function dashboardWidgetTreemapDefinitionRequestQuerySloQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQuerySloQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQuerySloQuery): any;
export declare function dashboardWidgetTreemapDefinitionRequestQuerySloQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQuerySloQueryOutputReference | DashboardWidgetTreemapDefinitionRequestQuerySloQuery): any;
export declare class DashboardWidgetTreemapDefinitionRequestQuerySloQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQuerySloQuery | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQuerySloQuery | undefined);
    private _additionalQueryFilters?;
    get additionalQueryFilters(): string;
    set additionalQueryFilters(value: string);
    resetAdditionalQueryFilters(): void;
    get additionalQueryFiltersInput(): string | undefined;
    private _crossOrgUuids?;
    get crossOrgUuids(): string[];
    set crossOrgUuids(value: string[]);
    resetCrossOrgUuids(): void;
    get crossOrgUuidsInput(): string[] | undefined;
    private _dataSource?;
    get dataSource(): string;
    set dataSource(value: string);
    get dataSourceInput(): string | undefined;
    private _groupMode?;
    get groupMode(): string;
    set groupMode(value: string);
    resetGroupMode(): void;
    get groupModeInput(): string | undefined;
    private _measure?;
    get measure(): string;
    set measure(value: string);
    get measureInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _sloId?;
    get sloId(): string;
    set sloId(value: string);
    get sloIdInput(): string | undefined;
    private _sloQueryType?;
    get sloQueryType(): string;
    set sloQueryType(value: string);
    resetSloQueryType(): void;
    get sloQueryTypeInput(): string | undefined;
}
export interface DashboardWidgetTreemapDefinitionRequestQuery {
    /**
    * apm_dependency_stats_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#apm_dependency_stats_query Dashboard#apm_dependency_stats_query}
    */
    readonly apmDependencyStatsQuery?: DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery;
    /**
    * apm_resource_stats_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#apm_resource_stats_query Dashboard#apm_resource_stats_query}
    */
    readonly apmResourceStatsQuery?: DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery;
    /**
    * cloud_cost_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#cloud_cost_query Dashboard#cloud_cost_query}
    */
    readonly cloudCostQuery?: DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery;
    /**
    * event_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#event_query Dashboard#event_query}
    */
    readonly eventQuery?: DashboardWidgetTreemapDefinitionRequestQueryEventQuery;
    /**
    * metric_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#metric_query Dashboard#metric_query}
    */
    readonly metricQuery?: DashboardWidgetTreemapDefinitionRequestQueryMetricQuery;
    /**
    * process_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#process_query Dashboard#process_query}
    */
    readonly processQuery?: DashboardWidgetTreemapDefinitionRequestQueryProcessQuery;
    /**
    * slo_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#slo_query Dashboard#slo_query}
    */
    readonly sloQuery?: DashboardWidgetTreemapDefinitionRequestQuerySloQuery;
}
export declare function dashboardWidgetTreemapDefinitionRequestQueryToTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQuery | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestQueryToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequestQuery | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequestQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequestQuery | cdktf.IResolvable | undefined);
    private _apmDependencyStatsQuery;
    get apmDependencyStatsQuery(): DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQueryOutputReference;
    putApmDependencyStatsQuery(value: DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery): void;
    resetApmDependencyStatsQuery(): void;
    get apmDependencyStatsQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryApmDependencyStatsQuery | undefined;
    private _apmResourceStatsQuery;
    get apmResourceStatsQuery(): DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQueryOutputReference;
    putApmResourceStatsQuery(value: DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery): void;
    resetApmResourceStatsQuery(): void;
    get apmResourceStatsQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryApmResourceStatsQuery | undefined;
    private _cloudCostQuery;
    get cloudCostQuery(): DashboardWidgetTreemapDefinitionRequestQueryCloudCostQueryOutputReference;
    putCloudCostQuery(value: DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery): void;
    resetCloudCostQuery(): void;
    get cloudCostQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryCloudCostQuery | undefined;
    private _eventQuery;
    get eventQuery(): DashboardWidgetTreemapDefinitionRequestQueryEventQueryOutputReference;
    putEventQuery(value: DashboardWidgetTreemapDefinitionRequestQueryEventQuery): void;
    resetEventQuery(): void;
    get eventQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryEventQuery | undefined;
    private _metricQuery;
    get metricQuery(): DashboardWidgetTreemapDefinitionRequestQueryMetricQueryOutputReference;
    putMetricQuery(value: DashboardWidgetTreemapDefinitionRequestQueryMetricQuery): void;
    resetMetricQuery(): void;
    get metricQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryMetricQuery | undefined;
    private _processQuery;
    get processQuery(): DashboardWidgetTreemapDefinitionRequestQueryProcessQueryOutputReference;
    putProcessQuery(value: DashboardWidgetTreemapDefinitionRequestQueryProcessQuery): void;
    resetProcessQuery(): void;
    get processQueryInput(): DashboardWidgetTreemapDefinitionRequestQueryProcessQuery | undefined;
    private _sloQuery;
    get sloQuery(): DashboardWidgetTreemapDefinitionRequestQuerySloQueryOutputReference;
    putSloQuery(value: DashboardWidgetTreemapDefinitionRequestQuerySloQuery): void;
    resetSloQuery(): void;
    get sloQueryInput(): DashboardWidgetTreemapDefinitionRequestQuerySloQuery | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequestQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestQueryOutputReference;
}
export interface DashboardWidgetTreemapDefinitionRequest {
    /**
    * formula block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#formula Dashboard#formula}
    */
    readonly formula?: DashboardWidgetTreemapDefinitionRequestFormula[] | cdktf.IResolvable;
    /**
    * query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query Dashboard#query}
    */
    readonly query?: DashboardWidgetTreemapDefinitionRequestQuery[] | cdktf.IResolvable;
}
export declare function dashboardWidgetTreemapDefinitionRequestToTerraform(struct?: DashboardWidgetTreemapDefinitionRequest | cdktf.IResolvable): any;
export declare function dashboardWidgetTreemapDefinitionRequestToHclTerraform(struct?: DashboardWidgetTreemapDefinitionRequest | cdktf.IResolvable): any;
export declare class DashboardWidgetTreemapDefinitionRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidgetTreemapDefinitionRequest | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinitionRequest | cdktf.IResolvable | undefined);
    private _formula;
    get formula(): DashboardWidgetTreemapDefinitionRequestFormulaList;
    putFormula(value: DashboardWidgetTreemapDefinitionRequestFormula[] | cdktf.IResolvable): void;
    resetFormula(): void;
    get formulaInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequestFormula[] | undefined;
    private _query;
    get query(): DashboardWidgetTreemapDefinitionRequestQueryList;
    putQuery(value: DashboardWidgetTreemapDefinitionRequestQuery[] | cdktf.IResolvable): void;
    resetQuery(): void;
    get queryInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequestQuery[] | undefined;
}
export declare class DashboardWidgetTreemapDefinitionRequestList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidgetTreemapDefinitionRequest[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetTreemapDefinitionRequestOutputReference;
}
export interface DashboardWidgetTreemapDefinition {
    /**
    * The title of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#title Dashboard#title}
    */
    readonly title?: string;
    /**
    * request block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#request Dashboard#request}
    */
    readonly request?: DashboardWidgetTreemapDefinitionRequest[] | cdktf.IResolvable;
}
export declare function dashboardWidgetTreemapDefinitionToTerraform(struct?: DashboardWidgetTreemapDefinitionOutputReference | DashboardWidgetTreemapDefinition): any;
export declare function dashboardWidgetTreemapDefinitionToHclTerraform(struct?: DashboardWidgetTreemapDefinitionOutputReference | DashboardWidgetTreemapDefinition): any;
export declare class DashboardWidgetTreemapDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetTreemapDefinition | undefined;
    set internalValue(value: DashboardWidgetTreemapDefinition | undefined);
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _request;
    get request(): DashboardWidgetTreemapDefinitionRequestList;
    putRequest(value: DashboardWidgetTreemapDefinitionRequest[] | cdktf.IResolvable): void;
    resetRequest(): void;
    get requestInput(): cdktf.IResolvable | DashboardWidgetTreemapDefinitionRequest[] | undefined;
}
export interface DashboardWidgetWidgetLayout {
    /**
    * The height of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#height Dashboard#height}
    */
    readonly height: number;
    /**
    * Whether the widget should be the first one on the second column in high density or not. Only one widget in the dashboard should have this property set to `true`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#is_column_break Dashboard#is_column_break}
    */
    readonly isColumnBreak?: boolean | cdktf.IResolvable;
    /**
    * The width of the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#width Dashboard#width}
    */
    readonly width: number;
    /**
    * The position of the widget on the x (horizontal) axis. Must be greater than or equal to 0.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#x Dashboard#x}
    */
    readonly x: number;
    /**
    * The position of the widget on the y (vertical) axis. Must be greater than or equal to 0.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#y Dashboard#y}
    */
    readonly y: number;
}
export declare function dashboardWidgetWidgetLayoutToTerraform(struct?: DashboardWidgetWidgetLayoutOutputReference | DashboardWidgetWidgetLayout): any;
export declare function dashboardWidgetWidgetLayoutToHclTerraform(struct?: DashboardWidgetWidgetLayoutOutputReference | DashboardWidgetWidgetLayout): any;
export declare class DashboardWidgetWidgetLayoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DashboardWidgetWidgetLayout | undefined;
    set internalValue(value: DashboardWidgetWidgetLayout | undefined);
    private _height?;
    get height(): number;
    set height(value: number);
    get heightInput(): number | undefined;
    private _isColumnBreak?;
    get isColumnBreak(): boolean | cdktf.IResolvable;
    set isColumnBreak(value: boolean | cdktf.IResolvable);
    resetIsColumnBreak(): void;
    get isColumnBreakInput(): boolean | cdktf.IResolvable | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    get widthInput(): number | undefined;
    private _x?;
    get x(): number;
    set x(value: number);
    get xInput(): number | undefined;
    private _y?;
    get y(): number;
    set y(value: number);
    get yInput(): number | undefined;
}
export interface DashboardWidget {
    /**
    * alert_graph_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#alert_graph_definition Dashboard#alert_graph_definition}
    */
    readonly alertGraphDefinition?: DashboardWidgetAlertGraphDefinition;
    /**
    * alert_value_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#alert_value_definition Dashboard#alert_value_definition}
    */
    readonly alertValueDefinition?: DashboardWidgetAlertValueDefinition;
    /**
    * change_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#change_definition Dashboard#change_definition}
    */
    readonly changeDefinition?: DashboardWidgetChangeDefinition;
    /**
    * check_status_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#check_status_definition Dashboard#check_status_definition}
    */
    readonly checkStatusDefinition?: DashboardWidgetCheckStatusDefinition;
    /**
    * distribution_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#distribution_definition Dashboard#distribution_definition}
    */
    readonly distributionDefinition?: DashboardWidgetDistributionDefinition;
    /**
    * event_stream_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#event_stream_definition Dashboard#event_stream_definition}
    */
    readonly eventStreamDefinition?: DashboardWidgetEventStreamDefinition;
    /**
    * event_timeline_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#event_timeline_definition Dashboard#event_timeline_definition}
    */
    readonly eventTimelineDefinition?: DashboardWidgetEventTimelineDefinition;
    /**
    * free_text_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#free_text_definition Dashboard#free_text_definition}
    */
    readonly freeTextDefinition?: DashboardWidgetFreeTextDefinition;
    /**
    * geomap_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#geomap_definition Dashboard#geomap_definition}
    */
    readonly geomapDefinition?: DashboardWidgetGeomapDefinition;
    /**
    * group_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#group_definition Dashboard#group_definition}
    */
    readonly groupDefinition?: DashboardWidgetGroupDefinition;
    /**
    * heatmap_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#heatmap_definition Dashboard#heatmap_definition}
    */
    readonly heatmapDefinition?: DashboardWidgetHeatmapDefinition;
    /**
    * hostmap_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#hostmap_definition Dashboard#hostmap_definition}
    */
    readonly hostmapDefinition?: DashboardWidgetHostmapDefinition;
    /**
    * iframe_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#iframe_definition Dashboard#iframe_definition}
    */
    readonly iframeDefinition?: DashboardWidgetIframeDefinition;
    /**
    * image_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#image_definition Dashboard#image_definition}
    */
    readonly imageDefinition?: DashboardWidgetImageDefinition;
    /**
    * list_stream_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#list_stream_definition Dashboard#list_stream_definition}
    */
    readonly listStreamDefinition?: DashboardWidgetListStreamDefinition;
    /**
    * log_stream_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#log_stream_definition Dashboard#log_stream_definition}
    */
    readonly logStreamDefinition?: DashboardWidgetLogStreamDefinition;
    /**
    * manage_status_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#manage_status_definition Dashboard#manage_status_definition}
    */
    readonly manageStatusDefinition?: DashboardWidgetManageStatusDefinition;
    /**
    * note_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#note_definition Dashboard#note_definition}
    */
    readonly noteDefinition?: DashboardWidgetNoteDefinition;
    /**
    * powerpack_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#powerpack_definition Dashboard#powerpack_definition}
    */
    readonly powerpackDefinition?: DashboardWidgetPowerpackDefinition;
    /**
    * query_table_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query_table_definition Dashboard#query_table_definition}
    */
    readonly queryTableDefinition?: DashboardWidgetQueryTableDefinition;
    /**
    * query_value_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#query_value_definition Dashboard#query_value_definition}
    */
    readonly queryValueDefinition?: DashboardWidgetQueryValueDefinition;
    /**
    * run_workflow_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#run_workflow_definition Dashboard#run_workflow_definition}
    */
    readonly runWorkflowDefinition?: DashboardWidgetRunWorkflowDefinition;
    /**
    * scatterplot_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#scatterplot_definition Dashboard#scatterplot_definition}
    */
    readonly scatterplotDefinition?: DashboardWidgetScatterplotDefinition;
    /**
    * service_level_objective_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#service_level_objective_definition Dashboard#service_level_objective_definition}
    */
    readonly serviceLevelObjectiveDefinition?: DashboardWidgetServiceLevelObjectiveDefinition;
    /**
    * servicemap_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#servicemap_definition Dashboard#servicemap_definition}
    */
    readonly servicemapDefinition?: DashboardWidgetServicemapDefinition;
    /**
    * slo_list_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#slo_list_definition Dashboard#slo_list_definition}
    */
    readonly sloListDefinition?: DashboardWidgetSloListDefinition;
    /**
    * split_graph_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#split_graph_definition Dashboard#split_graph_definition}
    */
    readonly splitGraphDefinition?: DashboardWidgetSplitGraphDefinition;
    /**
    * sunburst_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#sunburst_definition Dashboard#sunburst_definition}
    */
    readonly sunburstDefinition?: DashboardWidgetSunburstDefinition;
    /**
    * timeseries_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#timeseries_definition Dashboard#timeseries_definition}
    */
    readonly timeseriesDefinition?: DashboardWidgetTimeseriesDefinition;
    /**
    * toplist_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#toplist_definition Dashboard#toplist_definition}
    */
    readonly toplistDefinition?: DashboardWidgetToplistDefinition;
    /**
    * topology_map_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#topology_map_definition Dashboard#topology_map_definition}
    */
    readonly topologyMapDefinition?: DashboardWidgetTopologyMapDefinition;
    /**
    * trace_service_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#trace_service_definition Dashboard#trace_service_definition}
    */
    readonly traceServiceDefinition?: DashboardWidgetTraceServiceDefinition;
    /**
    * treemap_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#treemap_definition Dashboard#treemap_definition}
    */
    readonly treemapDefinition?: DashboardWidgetTreemapDefinition;
    /**
    * widget_layout block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.43.0/docs/resources/dashboard#widget_layout Dashboard#widget_layout}
    */
    readonly widgetLayout?: DashboardWidgetWidgetLayout;
}
export declare function dashboardWidgetToTerraform(struct?: DashboardWidget | cdktf.IResolvable): any;
export declare function dashboardWidgetToHclTerraform(struct?: DashboardWidget | cdktf.IResolvable): any;
export declare class DashboardWidgetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DashboardWidget | cdktf.IResolvable | undefined;
    set internalValue(value: DashboardWidget | cdktf.IResolvable | undefined);
    get id(): number;
    private _alertGraphDefinition;
    get alertGraphDefinition(): DashboardWidgetAlertGraphDefinitionOutputReference;
    putAlertGraphDefinition(value: DashboardWidgetAlertGraphDefinition): void;
    resetAlertGraphDefinition(): void;
    get alertGraphDefinitionInput(): DashboardWidgetAlertGraphDefinition | undefined;
    private _alertValueDefinition;
    get alertValueDefinition(): DashboardWidgetAlertValueDefinitionOutputReference;
    putAlertValueDefinition(value: DashboardWidgetAlertValueDefinition): void;
    resetAlertValueDefinition(): void;
    get alertValueDefinitionInput(): DashboardWidgetAlertValueDefinition | undefined;
    private _changeDefinition;
    get changeDefinition(): DashboardWidgetChangeDefinitionOutputReference;
    putChangeDefinition(value: DashboardWidgetChangeDefinition): void;
    resetChangeDefinition(): void;
    get changeDefinitionInput(): DashboardWidgetChangeDefinition | undefined;
    private _checkStatusDefinition;
    get checkStatusDefinition(): DashboardWidgetCheckStatusDefinitionOutputReference;
    putCheckStatusDefinition(value: DashboardWidgetCheckStatusDefinition): void;
    resetCheckStatusDefinition(): void;
    get checkStatusDefinitionInput(): DashboardWidgetCheckStatusDefinition | undefined;
    private _distributionDefinition;
    get distributionDefinition(): DashboardWidgetDistributionDefinitionOutputReference;
    putDistributionDefinition(value: DashboardWidgetDistributionDefinition): void;
    resetDistributionDefinition(): void;
    get distributionDefinitionInput(): DashboardWidgetDistributionDefinition | undefined;
    private _eventStreamDefinition;
    get eventStreamDefinition(): DashboardWidgetEventStreamDefinitionOutputReference;
    putEventStreamDefinition(value: DashboardWidgetEventStreamDefinition): void;
    resetEventStreamDefinition(): void;
    get eventStreamDefinitionInput(): DashboardWidgetEventStreamDefinition | undefined;
    private _eventTimelineDefinition;
    get eventTimelineDefinition(): DashboardWidgetEventTimelineDefinitionOutputReference;
    putEventTimelineDefinition(value: DashboardWidgetEventTimelineDefinition): void;
    resetEventTimelineDefinition(): void;
    get eventTimelineDefinitionInput(): DashboardWidgetEventTimelineDefinition | undefined;
    private _freeTextDefinition;
    get freeTextDefinition(): DashboardWidgetFreeTextDefinitionOutputReference;
    putFreeTextDefinition(value: DashboardWidgetFreeTextDefinition): void;
    resetFreeTextDefinition(): void;
    get freeTextDefinitionInput(): DashboardWidgetFreeTextDefinition | undefined;
    private _geomapDefinition;
    get geomapDefinition(): DashboardWidgetGeomapDefinitionOutputReference;
    putGeomapDefinition(value: DashboardWidgetGeomapDefinition): void;
    resetGeomapDefinition(): void;
    get geomapDefinitionInput(): DashboardWidgetGeomapDefinition | undefined;
    private _groupDefinition;
    get groupDefinition(): DashboardWidgetGroupDefinitionOutputReference;
    putGroupDefinition(value: DashboardWidgetGroupDefinition): void;
    resetGroupDefinition(): void;
    get groupDefinitionInput(): DashboardWidgetGroupDefinition | undefined;
    private _heatmapDefinition;
    get heatmapDefinition(): DashboardWidgetHeatmapDefinitionOutputReference;
    putHeatmapDefinition(value: DashboardWidgetHeatmapDefinition): void;
    resetHeatmapDefinition(): void;
    get heatmapDefinitionInput(): DashboardWidgetHeatmapDefinition | undefined;
    private _hostmapDefinition;
    get hostmapDefinition(): DashboardWidgetHostmapDefinitionOutputReference;
    putHostmapDefinition(value: DashboardWidgetHostmapDefinition): void;
    resetHostmapDefinition(): void;
    get hostmapDefinitionInput(): DashboardWidgetHostmapDefinition | undefined;
    private _iframeDefinition;
    get iframeDefinition(): DashboardWidgetIframeDefinitionOutputReference;
    putIframeDefinition(value: DashboardWidgetIframeDefinition): void;
    resetIframeDefinition(): void;
    get iframeDefinitionInput(): DashboardWidgetIframeDefinition | undefined;
    private _imageDefinition;
    get imageDefinition(): DashboardWidgetImageDefinitionOutputReference;
    putImageDefinition(value: DashboardWidgetImageDefinition): void;
    resetImageDefinition(): void;
    get imageDefinitionInput(): DashboardWidgetImageDefinition | undefined;
    private _listStreamDefinition;
    get listStreamDefinition(): DashboardWidgetListStreamDefinitionOutputReference;
    putListStreamDefinition(value: DashboardWidgetListStreamDefinition): void;
    resetListStreamDefinition(): void;
    get listStreamDefinitionInput(): DashboardWidgetListStreamDefinition | undefined;
    private _logStreamDefinition;
    get logStreamDefinition(): DashboardWidgetLogStreamDefinitionOutputReference;
    putLogStreamDefinition(value: DashboardWidgetLogStreamDefinition): void;
    resetLogStreamDefinition(): void;
    get logStreamDefinitionInput(): DashboardWidgetLogStreamDefinition | undefined;
    private _manageStatusDefinition;
    get manageStatusDefinition(): DashboardWidgetManageStatusDefinitionOutputReference;
    putManageStatusDefinition(value: DashboardWidgetManageStatusDefinition): void;
    resetManageStatusDefinition(): void;
    get manageStatusDefinitionInput(): DashboardWidgetManageStatusDefinition | undefined;
    private _noteDefinition;
    get noteDefinition(): DashboardWidgetNoteDefinitionOutputReference;
    putNoteDefinition(value: DashboardWidgetNoteDefinition): void;
    resetNoteDefinition(): void;
    get noteDefinitionInput(): DashboardWidgetNoteDefinition | undefined;
    private _powerpackDefinition;
    get powerpackDefinition(): DashboardWidgetPowerpackDefinitionOutputReference;
    putPowerpackDefinition(value: DashboardWidgetPowerpackDefinition): void;
    resetPowerpackDefinition(): void;
    get powerpackDefinitionInput(): DashboardWidgetPowerpackDefinition | undefined;
    private _queryTableDefinition;
    get queryTableDefinition(): DashboardWidgetQueryTableDefinitionOutputReference;
    putQueryTableDefinition(value: DashboardWidgetQueryTableDefinition): void;
    resetQueryTableDefinition(): void;
    get queryTableDefinitionInput(): DashboardWidgetQueryTableDefinition | undefined;
    private _queryValueDefinition;
    get queryValueDefinition(): DashboardWidgetQueryValueDefinitionOutputReference;
    putQueryValueDefinition(value: DashboardWidgetQueryValueDefinition): void;
    resetQueryValueDefinition(): void;
    get queryValueDefinitionInput(): DashboardWidgetQueryValueDefinition | undefined;
    private _runWorkflowDefinition;
    get runWorkflowDefinition(): DashboardWidgetRunWorkflowDefinitionOutputReference;
    putRunWorkflowDefinition(value: DashboardWidgetRunWorkflowDefinition): void;
    resetRunWorkflowDefinition(): void;
    get runWorkflowDefinitionInput(): DashboardWidgetRunWorkflowDefinition | undefined;
    private _scatterplotDefinition;
    get scatterplotDefinition(): DashboardWidgetScatterplotDefinitionOutputReference;
    putScatterplotDefinition(value: DashboardWidgetScatterplotDefinition): void;
    resetScatterplotDefinition(): void;
    get scatterplotDefinitionInput(): DashboardWidgetScatterplotDefinition | undefined;
    private _serviceLevelObjectiveDefinition;
    get serviceLevelObjectiveDefinition(): DashboardWidgetServiceLevelObjectiveDefinitionOutputReference;
    putServiceLevelObjectiveDefinition(value: DashboardWidgetServiceLevelObjectiveDefinition): void;
    resetServiceLevelObjectiveDefinition(): void;
    get serviceLevelObjectiveDefinitionInput(): DashboardWidgetServiceLevelObjectiveDefinition | undefined;
    private _servicemapDefinition;
    get servicemapDefinition(): DashboardWidgetServicemapDefinitionOutputReference;
    putServicemapDefinition(value: DashboardWidgetServicemapDefinition): void;
    resetServicemapDefinition(): void;
    get servicemapDefinitionInput(): DashboardWidgetServicemapDefinition | undefined;
    private _sloListDefinition;
    get sloListDefinition(): DashboardWidgetSloListDefinitionOutputReference;
    putSloListDefinition(value: DashboardWidgetSloListDefinition): void;
    resetSloListDefinition(): void;
    get sloListDefinitionInput(): DashboardWidgetSloListDefinition | undefined;
    private _splitGraphDefinition;
    get splitGraphDefinition(): DashboardWidgetSplitGraphDefinitionOutputReference;
    putSplitGraphDefinition(value: DashboardWidgetSplitGraphDefinition): void;
    resetSplitGraphDefinition(): void;
    get splitGraphDefinitionInput(): DashboardWidgetSplitGraphDefinition | undefined;
    private _sunburstDefinition;
    get sunburstDefinition(): DashboardWidgetSunburstDefinitionOutputReference;
    putSunburstDefinition(value: DashboardWidgetSunburstDefinition): void;
    resetSunburstDefinition(): void;
    get sunburstDefinitionInput(): DashboardWidgetSunburstDefinition | undefined;
    private _timeseriesDefinition;
    get timeseriesDefinition(): DashboardWidgetTimeseriesDefinitionOutputReference;
    putTimeseriesDefinition(value: DashboardWidgetTimeseriesDefinition): void;
    resetTimeseriesDefinition(): void;
    get timeseriesDefinitionInput(): DashboardWidgetTimeseriesDefinition | undefined;
    private _toplistDefinition;
    get toplistDefinition(): DashboardWidgetToplistDefinitionOutputReference;
    putToplistDefinition(value: DashboardWidgetToplistDefinition): void;
    resetToplistDefinition(): void;
    get toplistDefinitionInput(): DashboardWidgetToplistDefinition | undefined;
    private _topologyMapDefinition;
    get topologyMapDefinition(): DashboardWidgetTopologyMapDefinitionOutputReference;
    putTopologyMapDefinition(value: DashboardWidgetTopologyMapDefinition): void;
    resetTopologyMapDefinition(): void;
    get topologyMapDefinitionInput(): DashboardWidgetTopologyMapDefinition | undefined;
    private _traceServiceDefinition;
    get traceServiceDefinition(): DashboardWidgetTraceServiceDefinitionOutputReference;
    putTraceServiceDefinition(value: DashboardWidgetTraceServiceDefinition): void;
    resetTraceServiceDefinition(): void;
    get traceServiceDefinitionInput(): DashboardWidgetTraceServiceDefinition | undefined;
    private _treemapDefinition;
    get treemapDefinition(): DashboardWidgetTreemapDefinitionOutputReference;
    putTreemapDefinition(value: DashboardWidgetTreemapDefinition): void;
    resetTreemapDefinition(): void;
    get treemapDefinitionInput(): DashboardWidgetTreemapDefinition | undefined;
    private _widgetLayout;
    get widgetLayout(): DashboardWidgetWidgetLayoutOutputReference;
    putWidgetLayout(value: DashboardWidgetWidgetLayout): void;
    resetWidgetLayout(): void;
    get widgetLayoutInput(): DashboardWidgetWidgetLayout | undefined;
}
export declare class DashboardWidgetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DashboardWidget[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DashboardWidgetOutputReference;
}
